package com.example.myapplication

import com.google.gson.reflect.TypeToken
import com.hjq.gson.factory.GsonFactory
import java.math.BigDecimal

/**
 * Bean 类
 */
data class TestBean(
    //基础类型
    val base_1: String = "",
    val base_2: Boolean = false,
    val base_3: Int = 0,
    val base_4: Long = 0L,
    val base_5: Float = 0.0f,
    val base_6: Double = 0.0,
    val base_7: BigDecimal = BigDecimal(0),
    //数组集合
    val list_1: ArrayList<Any> = arrayListOf(),
    val list_2: ArrayList<String> = arrayListOf(),
    val list_3: ArrayList<Boolean> = arrayListOf(),
    val list_4: ArrayList<Int> = arrayListOf(),
    val list_5: ArrayList<Long> = arrayListOf(),
    val list_6: ArrayList<Float> = arrayListOf(),
    val list_7: ArrayList<Double> = arrayListOf(),
    val list_8: ArrayList<BigDecimal> = arrayListOf(),
    val list_9: ArrayList<TestBean> = arrayListOf(),
    val list_10: ArrayList<ArrayList<Any>> = arrayListOf(),
    val list_11: ArrayList<HashMap<String, Any>> = arrayListOf(),
    //Map集合
    val map_1: HashMap<String, Any> = hashMapOf(),
    val map_2: HashMap<String, String> = hashMapOf(),
    val map_3: HashMap<String, Boolean> = hashMapOf(),
    val map_4: HashMap<String, Int> = hashMapOf(),
    val map_5: HashMap<String, Long> = hashMapOf(),
    val map_6: HashMap<String, Float> = hashMapOf(),
    val map_7: HashMap<String, Double> = hashMapOf(),
    val map_8: HashMap<String, BigDecimal> = hashMapOf(),
    val map_9: HashMap<String, TestBean> = hashMapOf(),
    val map_10: HashMap<String, ArrayList<Any>> = hashMapOf(),
    val map_11: HashMap<String, HashMap<String, Any>> = hashMapOf(),
)

/**
 * 容错的范围
 * 新增了"\"字符串\"",因经测试发现空字符串和有字符串的情况下,测试表现不同
 */
private val faultRange = arrayListOf(null, "\"\"", "\"字符串\"", false, 0, 0.0, "{}", "[]")

fun main() {
    /****** 数组集合 ******/

    //数组集合-外层容错
    sample_1_by_list()  //结果: ❌ 

    //数组集合-泛型容错<String>
    sample_2_by_list()  //结果: ❌ 

    //数组集合-泛型容错<Boolean>
    sample_3_by_list()  //结果: ❌ 

    //数组集合-泛型容错<Int>
    sample_4_by_list()  //结果: ❌ 

    //数组集合-泛型容错<Long>
    sample_5_by_list()  //结果: ❌ 

    //数组集合-泛型容错<Float>
    sample_6_by_list()  //结果: ❌ 

    //数组集合-泛型容错<Double>
    sample_7_by_list()  //结果: ❌ 

    //数组集合-泛型容错<BigDecimal>
    sample_8_by_list()  //结果: ❌ 

    //数组集合-泛型容错<Bean对象>
    sample_9_by_list()  //结果: ❌ 

    //数组集合-泛型容错<数组集合>
    sample_10_by_list() //结果: ❌ 

    //数组集合-泛型容错<Map集合>
    sample_11_by_list() //结果: ❌ 

    /****** Map集合 ******/

    //Map集合-外层容错
    sample_1_by_map()   //结果: ❌ 

    //Map集合-泛型容错<String,String>
    sample_2_by_map()   //结果: ❌ 

    //Map集合-泛型容错<String,Boolean>
    sample_3_by_map()   //结果: ❌ 

    //Map集合-泛型容错<String,Int>
    sample_4_by_map()   //结果: ❌ 

    //Map集合-泛型容错<String,Long>
    sample_5_by_map()   //结果: ❌ 

    //Map集合-泛型容错<String,Float>
    sample_6_by_map()   //结果: ❌ 

    //Map集合-泛型容错<String,Double>
    sample_7_by_map()   //结果: ❌

    //Map集合-泛型容错<String,BigDecimal>
    sample_8_by_map()   //结果: ❌

    //Map集合-泛型容错<String,Bean对象>
    sample_9_by_map()   //结果: ❌

    //Map集合-泛型容错<String,数组集合>
    sample_10_by_map()   //结果: ❌

    //Map集合-泛型容错<String,Map集合>
    sample_11_by_map()   //结果: ❌

    /****** Bean类 ******/

    //Bean类-基本类型(String)
    sample_1_base_by_bean() //结果: ✅

    //Bean类-基本类型(Boolean)
    sample_2_base_by_bean() //结果: ✅

    //Bean类-基本类型(Int)
    sample_3_base_by_bean() //结果: ✅

    //Bean类-基本类型(Long)
    sample_4_base_by_bean() //结果: ✅

    //Bean类-基本类型(Float)
    sample_5_base_by_bean() //结果: ✅

    //Bean类-基本类型(Double)
    sample_6_base_by_bean() //结果: ✅

    //Bean类-基本类型(BigDecimal)
    sample_7_base_by_bean() //结果: ✅



    //Bean类-数组集合-外层容错
    sample_1_list_by_bean() //结果: ✅

    //Bean类-数组集合-泛型容错<String>
    sample_2_list_by_bean() //结果: ❌

    //Bean类-数组集合-泛型容错<Boolean>
    sample_3_list_by_bean() //结果: ❌

    //Bean类-数组集合-泛型容错<Int>
    sample_4_list_by_bean() //结果: ❌

    //Bean类-数组集合-泛型容错<Long>
    sample_5_list_by_bean() //结果: ❌

    //Bean类-数组集合-泛型容错<Float>
    sample_6_list_by_bean() //结果: ❌

    //Bean类-数组集合-泛型容错<Double>
    sample_7_list_by_bean() //结果: ❌

    //Bean类-数组集合-泛型容错<BigDecimal>
    sample_8_list_by_bean() //结果: ❌

    //Bean类-数组集合-泛型容错<Bean对象>
    sample_9_list_by_bean() //结果: ❌

    //Bean类-数组集合-泛型容错<数组集合>
    sample_10_list_by_bean() //结果: ❌

    //Bean类-数组集合-泛型容错<Map集合>
    sample_11_list_by_bean() //结果: ❌



    //Bean类-Map集合-外层容错
    sample_1_map_by_bean()   //结果: ✅

    //Bean类-Map集合-泛型容错<String,String>
    sample_2_map_by_bean()   //结果: ❌

    //Bean类-Map集合-泛型容错<String,Boolean>
    sample_3_map_by_bean()   //结果: ❌

    //Bean类-Map集合-泛型容错<String,Int>
    sample_4_map_by_bean()   //结果: ❌

    //Bean类-Map集合-泛型容错<String,Long>
    sample_5_map_by_bean()   //结果: ❌

    //Bean类-Map集合-泛型容错<String,Float>
    sample_6_map_by_bean()   //结果: ❌

    //Bean类-Map集合-泛型容错<String,Double>
    sample_7_map_by_bean()   //结果: ❌

    //Bean类-Map集合-泛型容错<String,BigDecimal>
    sample_8_map_by_bean()   //结果: ❌

    //Bean类-Map集合-泛型容错<String,Bean对象>
    sample_9_map_by_bean()   //结果: ❌

    //Bean类-Map集合-泛型容错<String,数组集合>
    sample_10_map_by_bean()   //结果: ❌

    //Bean类-Map集合-泛型容错<String,Map集合>
    sample_11_map_by_bean()   //结果: ❌
}

fun sample_1_by_list() {
    println("数组集合-外层容错")
    faultRange.forEachIndexed { index, it ->
        val json = "${it}"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson<ArrayList<Any>>(json, object : TypeToken<ArrayList<Any>>() {}.type)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(bean))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① null -> null
    //② "" -> null
    //③ "字符串" -> null
    //④ false -> null
    //⑤ 0 -> null
    //⑥ 0.0 -> null
    //⑦ {} -> null
    //⑧ [] -> []
    //验证是否通过: ❌ 第1、2、3、4、5、6、7 结果不对
    //建议: 解析成ArrayList时, 类型不匹配会返回null, 但在其他地方则不会null, 比如bean对象中的list。不兼容的话在调用时还是会null空指针的 ,后续凡是返回有null值的 ,参考这条。
}

fun sample_2_by_list() {
    println("数组集合-泛型容错<String>")
    faultRange.forEachIndexed { index, it ->
        val json = "[${it}]"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson<ArrayList<String>>(json, object : TypeToken<ArrayList<String>>() {}.type)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(bean))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① [null] -> [null]
    //② [""] -> [""]
    //③ ["字符串"] -> ["字符串"]
    //④ [false] -> ["false"]
    //⑤ [0] -> ["0"]
    //⑥ [0.0] -> ["0.0"]
    //⑦ [{}] -> java.lang.IllegalArgumentException
    //⑧ [[]] -> java.lang.IllegalArgumentException
    //验证是否通过: ❌ 第1、7、8 结果不对
}

fun sample_3_by_list() {
    println("数组集合-泛型容错<Boolean>")
    faultRange.forEachIndexed { index, it ->
        val json = "[${it}]"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson<ArrayList<Boolean>>(json, object : TypeToken<ArrayList<Boolean>>() {}.type)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(bean))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① [null] -> [null]
    //② [""] -> [false]
    //③ ["字符串"] -> [false]
    //④ [false] -> [false]
    //⑤ [0] -> [false]
    //⑥ [0.0] -> [false]
    //⑦ [{}] -> java.lang.IllegalArgumentException
    //⑧ [[]] -> java.lang.IllegalArgumentException
    //验证是否通过: ❌ 第1、7、8 结果不对
}

fun sample_4_by_list() {
    println("数组集合-泛型容错<Int>")
    faultRange.forEachIndexed { index, it ->
        val json = "[${it}]"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson<ArrayList<Int>>(json, object : TypeToken<ArrayList<Int>>() {}.type)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(bean))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① [null] -> [null]
    //② [""] -> [0]
    //③ ["字符串"] -> java.lang.NumberFormatException: Character 字 is neither a decimal digit number, decimal point, nor "e" notation exponential mark.
    //④ [false] -> java.lang.IllegalArgumentException
    //⑤ [0] -> [0]
    //⑥ [0.0] -> [0]
    //⑦ [{}] -> java.lang.IllegalArgumentException
    //⑧ [[]] -> java.lang.IllegalArgumentException
    //验证是否通过: ❌ 第1、3、4、7、8 结果不对
}

fun sample_5_by_list() {
    println("数组集合-泛型容错<Long>")
    faultRange.forEachIndexed { index, it ->
        val json = "[${it}]"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson<ArrayList<Long>>(json, object : TypeToken<ArrayList<Long>>() {}.type)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(bean))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① [null] -> [null]
    //② [""] -> [0]
    //③ ["字符串"] -> java.lang.NumberFormatException: Character 字 is neither a decimal digit number, decimal point, nor "e" notation exponential mark.
    //④ [false] -> java.lang.IllegalArgumentException
    //⑤ [0] -> [0]
    //⑥ [0.0] -> [0]
    //⑦ [{}] -> java.lang.IllegalArgumentException
    //⑧ [[]] -> java.lang.IllegalArgumentException
    //验证是否通过: ❌ 第1、3、4、7、8 结果不对
}

fun sample_6_by_list() {
    println("数组集合-泛型容错<Float>")
    faultRange.forEachIndexed { index, it ->
        val json = "[${it}]"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson<ArrayList<Float>>(json, object : TypeToken<ArrayList<Float>>() {}.type)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(bean))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① [null] -> [null]
    //② [""] -> [0.0]
    //③ ["字符串"] -> java.lang.NumberFormatException: For input string: "字符串"
    //④ [false] -> java.lang.IllegalArgumentException
    //⑤ [0] -> [0.0]
    //⑥ [0.0] -> [0.0]
    //⑦ [{}] -> java.lang.IllegalArgumentException
    //⑧ [[]] -> java.lang.IllegalArgumentException
    //验证是否通过: ❌ 第1、3、4、7、8 结果不对
}

fun sample_7_by_list() {
    println("数组集合-泛型容错<Double>")
    faultRange.forEachIndexed { index, it ->
        val json = "[${it}]"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson<ArrayList<Double>>(json, object : TypeToken<ArrayList<Double>>() {}.type)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(bean))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① [null] -> [null]
    //② [""] -> [0.0]
    //③ ["字符串"] -> java.lang.NumberFormatException: For input string: "字符串"
    //④ [false] -> java.lang.IllegalArgumentException
    //⑤ [0] -> [0.0]
    //⑥ [0.0] -> [0.0]
    //⑦ [{}] -> java.lang.IllegalArgumentException
    //⑧ [[]] -> java.lang.IllegalArgumentException
    //验证是否通过: ❌ 第1、3、4、7、8 结果不对
}

fun sample_8_by_list() {
    println("数组集合-泛型容错<BigDecimal>")
    faultRange.forEachIndexed { index, it ->
        val json = "[${it}]"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson<ArrayList<BigDecimal>>(json, object : TypeToken<ArrayList<BigDecimal>>() {}.type)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(bean))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① [null] -> [null]
    //② [""] -> [0]
    //③ ["字符串"] -> java.lang.NumberFormatException: Character 字 is neither a decimal digit number, decimal point, nor "e" notation exponential mark.
    //④ [false] -> [null]
    //⑤ [0] -> [0]
    //⑥ [0.0] -> [0.0]
    //⑦ [{}] -> [null]
    //⑧ [[]] -> [null]
    //验证是否通过: ❌ 第1、3、4、7、8 结果不对
}

fun sample_9_by_list() {
    println("数组集合-泛型容错<Bean对象>")
    faultRange.forEachIndexed { index, it ->
        val json = "[${it}]"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson<ArrayList<TestBean>>(json, object : TypeToken<ArrayList<TestBean>>() {}.type)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(bean))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① [null] -> [null]
    //② [""] -> [null]
    //③ ["字符串"] -> [null]
    //④ [false] -> [null]
    //⑤ [0] -> [null]
    //⑥ [0.0] -> [null]
    //⑦ [{}] -> [{"base_1":"","base_2":false,"base_3":0,"base_4":0,"base_5":0.0,"base_6":0.0,"base_7":0,"list_1":[],"list_2":[],"list_3":[],"list_4":[],"list_5":[],"list_6":[],"list_7":[],"list_8":[],"list_9":[],"list_10":[],"list_11":[],"map_1":{},"map_2":{},"map_3":{},"map_4":{},"map_5":{},"map_6":{},"map_7":{},"map_8":{},"map_9":{},"map_10":{},"map_11":{}}]
    //⑧ [[]] -> [null]
    //验证是否通过: ❌ 第1、2、3、4、5、6、8 结果不对
}

fun sample_10_by_list() {
    println("数组集合-泛型容错<数组集合>")
    faultRange.forEachIndexed { index, it ->
        val json = "[${it}]"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson<ArrayList<ArrayList<Any>>>(json, object : TypeToken<ArrayList<ArrayList<Any>>>() {}.type)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(bean))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① [null] -> [null]
    //② [""] -> [null]
    //③ ["字符串"] -> [null]
    //④ [false] -> [null]
    //⑤ [0] -> [null]
    //⑥ [0.0] -> [null]
    //⑦ [{}] -> [null]
    //⑧ [[]] -> [[]]
    //验证是否通过: ❌ 第1、2、3、4、5、6、7 结果不对
}

fun sample_11_by_list() {
    println("数组集合-泛型容错<Map集合>")
    faultRange.forEachIndexed { index, it ->
        val json = "[${it}]"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson<ArrayList<HashMap<String, Any>>>(json, object : TypeToken<ArrayList<HashMap<String, Any>>>() {}.type)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(bean))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① [null] -> [null]
    //② [""] -> [{}]
    //③ ["字符串"] -> [{}]
    //④ [false] -> [{}]
    //⑤ [0] -> [{}]
    //⑥ [0.0] -> [{}]
    //⑦ [{}] -> [{}]
    //⑧ [[]] -> [{}]
    //验证是否通过: ❌ 第1 结果不对
}

fun sample_1_by_map() {
    println("Map集合-外层容错")
    faultRange.forEachIndexed { index, it ->
        val json = "${it}"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson<HashMap<String, Any>>(json, object : TypeToken<HashMap<String, Any>>() {}.type)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(bean))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① null -> null
    //② "" -> {}
    //③ "字符串" -> {}
    //④ false -> {}
    //⑤ 0 -> {}
    //⑥ 0.0 -> {}
    //⑦ {} -> {}
    //⑧ [] -> {}
    //验证是否通过: ❌ 第1 结果不对
}

fun sample_2_by_map() {
    println("Map集合-泛型容错<String,String>")
    faultRange.forEachIndexed { index, it ->
        val json = "{${it}}"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson<HashMap<String, String>>(json, object : TypeToken<HashMap<String, String>>() {}.type)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(bean))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① {null} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 7 path $.
    //② {""} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 5 path $.
    //③ {"字符串"} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 8 path $.
    //④ {false} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 8 path $.
    //⑤ {0} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 4 path $.
    //⑥ {0.0} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 6 path $.
    //⑦ {{}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected name at line 1 column 2 path $.
    //⑧ {[]} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected name at line 1 column 2 path $.
    //验证是否通过: ❌ 第1、2、3、4、5、6、7、8 结果不对
}

fun sample_3_by_map() {
    println("Map集合-泛型容错<String,Boolean>")
    faultRange.forEachIndexed { index, it ->
        val json = "{${it}}"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson<HashMap<String, Boolean>>(json, object : TypeToken<HashMap<String, Boolean>>() {}.type)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(bean))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① {null} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 7 path $.
    //② {""} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 5 path $.
    //③ {"字符串"} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 8 path $.
    //④ {false} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 8 path $.
    //⑤ {0} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 4 path $.
    //⑥ {0.0} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 6 path $.
    //⑦ {{}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected name at line 1 column 2 path $.
    //⑧ {[]} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected name at line 1 column 2 path $.
    //验证是否通过: ❌ 第1、2、3、4、5、6、7、8 结果不对
}

fun sample_4_by_map() {
    println("Map集合-泛型容错<String,Int>")
    faultRange.forEachIndexed { index, it ->
        val json = "{${it}}"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson<HashMap<String, Int>>(json, object : TypeToken<HashMap<String, Int>>() {}.type)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(bean))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① {null} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 7 path $.
    //② {""} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 5 path $.
    //③ {"字符串"} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 8 path $.
    //④ {false} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 8 path $.
    //⑤ {0} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 4 path $.
    //⑥ {0.0} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 6 path $.
    //⑦ {{}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected name at line 1 column 2 path $.
    //⑧ {[]} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected name at line 1 column 2 path $.
    //验证是否通过: ❌ 第1、2、3、4、5、6、7、8 结果不对
}

fun sample_5_by_map() {
    println("Map集合-泛型容错<String,Long>")
    faultRange.forEachIndexed { index, it ->
        val json = "{${it}}"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson<HashMap<String, Long>>(json, object : TypeToken<HashMap<String, Long>>() {}.type)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(bean))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① {null} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 7 path $.
    //② {""} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 5 path $.
    //③ {"字符串"} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 8 path $.
    //④ {false} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 8 path $.
    //⑤ {0} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 4 path $.
    //⑥ {0.0} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 6 path $.
    //⑦ {{}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected name at line 1 column 2 path $.
    //⑧ {[]} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected name at line 1 column 2 path $.
    //验证是否通过: ❌ 第1、2、3、4、5、6、7、8 结果不对
}

fun sample_6_by_map() {
    println("Map集合-泛型容错<String,Float>")
    faultRange.forEachIndexed { index, it ->
        val json = "{${it}}"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson<HashMap<String, Float>>(json, object : TypeToken<HashMap<String, Float>>() {}.type)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(bean))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① {null} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 7 path $.
    //② {""} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 5 path $.
    //③ {"字符串"} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 8 path $.
    //④ {false} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 8 path $.
    //⑤ {0} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 4 path $.
    //⑥ {0.0} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 6 path $.
    //⑦ {{}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected name at line 1 column 2 path $.
    //⑧ {[]} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected name at line 1 column 2 path $.
    //验证是否通过: ❌ 第1、2、3、4、5、6、7、8 结果不对
}

fun sample_7_by_map() {
    println("Map集合-泛型容错<String,Double>")
    faultRange.forEachIndexed { index, it ->
        val json = "{${it}}"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson<HashMap<String, Double>>(json, object : TypeToken<HashMap<String, Double>>() {}.type)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(bean))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① {null} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 7 path $.
    //② {""} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 5 path $.
    //③ {"字符串"} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 8 path $.
    //④ {false} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 8 path $.
    //⑤ {0} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 4 path $.
    //⑥ {0.0} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 6 path $.
    //⑦ {{}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected name at line 1 column 2 path $.
    //⑧ {[]} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected name at line 1 column 2 path $.
    //验证是否通过: ❌ 第1、2、3、4、5、6、7、8 结果不对
}

fun sample_8_by_map() {
    println("Map集合-泛型容错<String,BigDecimal>")
    faultRange.forEachIndexed { index, it ->
        val json = "{${it}}"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson<HashMap<String, BigDecimal>>(json, object : TypeToken<HashMap<String, BigDecimal>>() {}.type)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(bean))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① {null} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 7 path $.
    //② {""} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 5 path $.
    //③ {"字符串"} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 8 path $.
    //④ {false} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 8 path $.
    //⑤ {0} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 4 path $.
    //⑥ {0.0} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 6 path $.
    //⑦ {{}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected name at line 1 column 2 path $.
    //⑧ {[]} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected name at line 1 column 2 path $.
    //验证是否通过: ❌ 第1、2、3、4、5、6、7、8 结果不对
}

fun sample_9_by_map() {
    println("Map集合-泛型容错<String,Bean对象>")
    faultRange.forEachIndexed { index, it ->
        val json = "{${it}}"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson<HashMap<String, TestBean>>(json, object : TypeToken<HashMap<String, TestBean>>() {}.type)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(bean))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① {null} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 7 path $.
    //② {""} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 5 path $.
    //③ {"字符串"} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 8 path $.
    //④ {false} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 8 path $.
    //⑤ {0} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 4 path $.
    //⑥ {0.0} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 6 path $.
    //⑦ {{}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected name at line 1 column 2 path $.
    //⑧ {[]} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected name at line 1 column 2 path $.
    //验证是否通过: ❌ 第1、2、3、4、5、6、7、8 结果不对
}

fun sample_10_by_map() {
    println("Map集合-泛型容错<String,数组集合>")
    faultRange.forEachIndexed { index, it ->
        val json = "{${it}}"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson<HashMap<String, ArrayList<Any>>>(json, object : TypeToken<HashMap<String, TestBean>>() {}.type)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(bean))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① {null} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 7 path $.
    //② {""} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 5 path $.
    //③ {"字符串"} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 8 path $.
    //④ {false} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 8 path $.
    //⑤ {0} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 4 path $.
    //⑥ {0.0} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 6 path $.
    //⑦ {{}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected name at line 1 column 2 path $.
    //⑧ {[]} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected name at line 1 column 2 path $.
    //验证是否通过: ❌ 第1、2、3、4、5、6、7、8 结果不对
}

fun sample_11_by_map() {
    println("Map集合-泛型容错<String,Map集合>")
    faultRange.forEachIndexed { index, it ->
        val json = "{${it}}"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson<HashMap<String, HashMap<String, Any>>>(json, object : TypeToken<HashMap<String, HashMap<String, Any>>>() {}.type)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(bean))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① {null} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 7 path $.
    //② {""} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 5 path $.
    //③ {"字符串"} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 8 path $.
    //④ {false} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 8 path $.
    //⑤ {0} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 4 path $.
    //⑥ {0.0} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 6 path $.
    //⑦ {{}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected name at line 1 column 2 path $.
    //⑧ {[]} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected name at line 1 column 2 path $.
    //验证是否通过: ❌ 第1、2、3、4、5、6、7、8 结果不对
}

fun sample_1_base_by_bean() {
    println("Bean类-基本类型(String)")
    faultRange.forEachIndexed { index, it ->
        val json = "{\"base_1\":${it}}";
        try {
            val bean = GsonFactory.getSingletonGson().fromJson(json, TestBean::class.java)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(mapOf("base_1" to bean.base_1)))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① {"base_1":null} -> {"base_1":""}
    //② {"base_1":""} -> {"base_1":""}
    //③ {"base_1":"字符串"} -> {"base_1":"字符串"}
    //④ {"base_1":false} -> {"base_1":"false"}
    //⑤ {"base_1":0} -> {"base_1":"0"}
    //⑥ {"base_1":0.0} -> {"base_1":"0.0"}
    //⑦ {"base_1":{}} -> {"base_1":""}
    //⑧ {"base_1":[]} -> {"base_1":""}
    //验证是否通过: ✅
}

fun sample_2_base_by_bean() {
    println("Bean类-基本类型(Boolean)")
    faultRange.forEachIndexed { index, it ->
        val json = "{\"base_2\":${it}}";
        try {
            val bean = GsonFactory.getSingletonGson().fromJson(json, TestBean::class.java)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(mapOf("base_2" to bean.base_2)))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① {"base_2":null} -> {"base_2":false}
    //② {"base_2":""} -> {"base_2":false}
    //③ {"base_2":"字符串"} -> {"base_2":false}
    //④ {"base_2":false} -> {"base_2":false}
    //⑤ {"base_2":0} -> {"base_2":false}
    //⑥ {"base_2":0.0} -> {"base_2":false}
    //⑦ {"base_2":{}} -> {"base_2":false}
    //⑧ {"base_2":[]} -> {"base_2":false}
    //验证是否通过: ✅
}

fun sample_3_base_by_bean() {
    println("Bean类-基本类型(Int)")
    faultRange.forEachIndexed { index, it ->
        val json = "{\"base_3\":${it}}";
        try {
            val bean = GsonFactory.getSingletonGson().fromJson(json, TestBean::class.java)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(mapOf("base_3" to bean.base_3)))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① {"base_3":null} -> {"base_3":0}
    //② {"base_3":""} -> {"base_3":0}
    //③ {"base_3":"字符串"} -> {"base_3":0}
    //④ {"base_3":false} -> {"base_3":0}
    //⑤ {"base_3":0} -> {"base_3":0}
    //⑥ {"base_3":0.0} -> {"base_3":0}
    //⑦ {"base_3":{}} -> {"base_3":0}
    //⑧ {"base_3":[]} -> {"base_3":0}
    //验证是否通过: ✅
}

fun sample_4_base_by_bean() {
    println("Bean类-基本类型(Long)")
    faultRange.forEachIndexed { index, it ->
        val json = "{\"base_4\":${it}}";
        try {
            val bean = GsonFactory.getSingletonGson().fromJson(json, TestBean::class.java)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(mapOf("base_4" to bean.base_4)))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① {"base_4":null} -> {"base_4":0}
    //② {"base_4":""} -> {"base_4":0}
    //③ {"base_4":"字符串"} -> {"base_4":0}
    //④ {"base_4":false} -> {"base_4":0}
    //⑤ {"base_4":0} -> {"base_4":0}
    //⑥ {"base_4":0.0} -> {"base_4":0}
    //⑦ {"base_4":{}} -> {"base_4":0}
    //⑧ {"base_4":[]} -> {"base_4":0}
    //验证是否通过: ✅
}

fun sample_5_base_by_bean() {
    println("Bean类-基本类型(Float)")
    faultRange.forEachIndexed { index, it ->
        val json = "{\"base_5\":${it}}";
        try {
            val bean = GsonFactory.getSingletonGson().fromJson(json, TestBean::class.java)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(mapOf("base_5" to bean.base_5)))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① {"base_5":null} -> {"base_5":0.0}
    //② {"base_5":""} -> {"base_5":0.0}
    //③ {"base_5":"字符串"} -> {"base_5":0.0}
    //④ {"base_5":false} -> {"base_5":0.0}
    //⑤ {"base_5":0} -> {"base_5":0.0}
    //⑥ {"base_5":0.0} -> {"base_5":0.0}
    //⑦ {"base_5":{}} -> {"base_5":0.0}
    //⑧ {"base_5":[]} -> {"base_5":0.0}
    //验证是否通过: ✅
}

fun sample_6_base_by_bean() {
    println("Bean类-基本类型(Double)")
    faultRange.forEachIndexed { index, it ->
        val json = "{\"base_6\":${it}}";
        try {
            val bean = GsonFactory.getSingletonGson().fromJson(json, TestBean::class.java)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(mapOf("base_6" to bean.base_6)))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① {"base_6":null} -> {"base_6":0.0}
    //② {"base_6":""} -> {"base_6":0.0}
    //③ {"base_6":"字符串"} -> {"base_6":0.0}
    //④ {"base_6":false} -> {"base_6":0.0}
    //⑤ {"base_6":0} -> {"base_6":0.0}
    //⑥ {"base_6":0.0} -> {"base_6":0.0}
    //⑦ {"base_6":{}} -> {"base_6":0.0}
    //⑧ {"base_6":[]} -> {"base_6":0.0}
    //验证是否通过: ✅
}

fun sample_7_base_by_bean() {
    println("Bean类-基本类型(BigDecimal)")
    faultRange.forEachIndexed { index, it ->
        val json = "{\"base_7\":${it}}";
        try {
            val bean = GsonFactory.getSingletonGson().fromJson(json, TestBean::class.java)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(mapOf("base_7" to bean.base_7)))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //Bean类-基本类型(BigDecimal)
    //① {"base_7":null} -> {"base_7":0}
    //② {"base_7":""} -> {"base_7":0}
    //③ {"base_7":"字符串"} -> {"base_7":0}
    //④ {"base_7":false} -> {"base_7":0}
    //⑤ {"base_7":0} -> {"base_7":0}
    //⑥ {"base_7":0.0} -> {"base_7":0.0}
    //⑦ {"base_7":{}} -> {"base_7":0}
    //⑧ {"base_7":[]} -> {"base_7":0}
    //验证是否通过: ✅
}

fun sample_1_list_by_bean() {
    println("Bean类-数组集合-外层容错")
    faultRange.forEachIndexed { index, it ->
        val json = "{\"list_1\":${it}}"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson(json, TestBean::class.java)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(mapOf("list_1" to bean.list_1)))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① {"list_1":null} -> {"list_1":[]}
    //② {"list_1":""} -> {"list_1":[]}
    //③ {"list_1":"字符串"} -> {"list_1":[]}
    //④ {"list_1":false} -> {"list_1":[]}
    //⑤ {"list_1":0} -> {"list_1":[]}
    //⑥ {"list_1":0.0} -> {"list_1":[]}
    //⑦ {"list_1":{}} -> {"list_1":[]}
    //⑧ {"list_1":[]} -> {"list_1":[]}
    //验证是否通过: ✅
}

fun sample_2_list_by_bean() {
    println("Bean类-数组集合-泛型容错<String>")
    faultRange.forEachIndexed { index, it ->
        val json = "{\"list_2\":[${it}]}"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson(json, TestBean::class.java)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(mapOf("list_2" to bean.list_2)))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① {"list_2":[null]} -> {"list_2":[null]}
    //② {"list_2":[""]} -> {"list_2":[""]}
    //③ {"list_2":["字符串"]} -> {"list_2":["字符串"]}
    //④ {"list_2":[false]} -> {"list_2":["false"]}
    //⑤ {"list_2":[0]} -> {"list_2":["0"]}
    //⑥ {"list_2":[0.0]} -> {"list_2":["0.0"]}
    //⑦ {"list_2":[{}]} -> com.google.gson.JsonSyntaxException: java.lang.IllegalStateException: Expected END_OBJECT but was END_ARRAY at line 1 column 15 path $.list_2[1]
    //⑧ {"list_2":[[]]} -> com.google.gson.JsonSyntaxException: java.lang.IllegalStateException: Expected END_OBJECT but was END_ARRAY at line 1 column 15 path $.list_2[1]
    //验证是否通过: ❌ 第1、7、8结果不对
}

fun sample_3_list_by_bean() {
    println("Bean类-数组集合-泛型容错<Boolean>")
    faultRange.forEachIndexed { index, it ->
        val json = "{\"list_3\":[${it}]}"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson(json, TestBean::class.java)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(mapOf("list_3" to bean.list_3)))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① {"list_3":[null]} -> {"list_3":[null]}
    //② {"list_3":[""]} -> {"list_3":[false]}
    //③ {"list_3":["字符串"]} -> {"list_3":[false]}
    //④ {"list_3":[false]} -> {"list_3":[false]}
    //⑤ {"list_3":[0]} -> {"list_3":[false]}
    //⑥ {"list_3":[0.0]} -> {"list_3":[false]}
    //⑦ {"list_3":[{}]} -> com.google.gson.JsonSyntaxException: java.lang.IllegalStateException: Expected END_OBJECT but was END_ARRAY at line 1 column 15 path $.list_3[1]
    //⑧ {"list_3":[[]]} -> com.google.gson.JsonSyntaxException: java.lang.IllegalStateException: Expected END_OBJECT but was END_ARRAY at line 1 column 15 path $.list_3[1]
    //验证是否通过: ❌ 第1、7、8结果不对
}

fun sample_4_list_by_bean() {
    println("Bean类-数组集合-泛型容错<Int>")
    faultRange.forEachIndexed { index, it ->
        val json = "{\"list_4\":[${it}]}"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson(json, TestBean::class.java)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(mapOf("list_4" to bean.list_4)))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① {"list_4":[null]} -> {"list_4":[null]}
    //② {"list_4":[""]} -> {"list_4":[0]}
    //③ {"list_4":["字符串"]} -> com.google.gson.JsonSyntaxException: java.lang.IllegalStateException: Expected END_OBJECT but was END_ARRAY at line 1 column 18 path $.list_4[1]
    //④ {"list_4":[false]} -> com.google.gson.JsonSyntaxException: java.lang.IllegalStateException: Expected END_OBJECT but was END_ARRAY at line 1 column 18 path $.list_4[1]
    //⑤ {"list_4":[0]} -> {"list_4":[0]}
    //⑥ {"list_4":[0.0]} -> {"list_4":[0]}
    //⑦ {"list_4":[{}]} -> com.google.gson.JsonSyntaxException: java.lang.IllegalStateException: Expected END_OBJECT but was END_ARRAY at line 1 column 15 path $.list_4[1]
    //⑧ {"list_4":[[]]} -> com.google.gson.JsonSyntaxException: java.lang.IllegalStateException: Expected END_OBJECT but was END_ARRAY at line 1 column 15 path $.list_4[1]
    //验证是否通过: ❌ 第1、3、4、7、8 结果不对
}

fun sample_5_list_by_bean() {
    println("Bean类-数组集合-泛型容错<Long>")
    faultRange.forEachIndexed { index, it ->
        val json = "{\"list_5\":[${it}]}"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson(json, TestBean::class.java)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(mapOf("list_5" to bean.list_5)))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① {"list_5":[null]} -> {"list_5":[null]}
    //② {"list_5":[""]} -> {"list_5":[0]}
    //③ {"list_5":["字符串"]} -> com.google.gson.JsonSyntaxException: java.lang.IllegalStateException: Expected END_OBJECT but was END_ARRAY at line 1 column 18 path $.list_5[1]
    //④ {"list_5":[false]} -> com.google.gson.JsonSyntaxException: java.lang.IllegalStateException: Expected END_OBJECT but was END_ARRAY at line 1 column 18 path $.list_5[1]
    //⑤ {"list_5":[0]} -> {"list_5":[0]}
    //⑥ {"list_5":[0.0]} -> {"list_5":[0]}
    //⑦ {"list_5":[{}]} -> com.google.gson.JsonSyntaxException: java.lang.IllegalStateException: Expected END_OBJECT but was END_ARRAY at line 1 column 15 path $.list_5[1]
    //⑧ {"list_5":[[]]} -> com.google.gson.JsonSyntaxException: java.lang.IllegalStateException: Expected END_OBJECT but was END_ARRAY at line 1 column 15 path $.list_5[1]
    //验证是否通过: ❌ 第1、3、4、7、8 结果不对
}

fun sample_6_list_by_bean() {
    println("Bean类-数组集合-泛型容错<Float>")
    faultRange.forEachIndexed { index, it ->
        val json = "{\"list_6\":[${it}]}"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson(json, TestBean::class.java)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(mapOf("list_6" to bean.list_6)))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① {"list_6":[null]} -> {"list_6":[null]}
    //② {"list_6":[""]} -> {"list_6":[0.0]}
    //③ {"list_6":["字符串"]} -> com.google.gson.JsonSyntaxException: java.lang.IllegalStateException: Expected END_OBJECT but was END_ARRAY at line 1 column 18 path $.list_6[1]
    //④ {"list_6":[false]} -> com.google.gson.JsonSyntaxException: java.lang.IllegalStateException: Expected END_OBJECT but was END_ARRAY at line 1 column 18 path $.list_6[1]
    //⑤ {"list_6":[0]} -> {"list_6":[0.0]}
    //⑥ {"list_6":[0.0]} -> {"list_6":[0.0]}
    //⑦ {"list_6":[{}]} -> com.google.gson.JsonSyntaxException: java.lang.IllegalStateException: Expected END_OBJECT but was END_ARRAY at line 1 column 15 path $.list_6[1]
    //⑧ {"list_6":[[]]} -> com.google.gson.JsonSyntaxException: java.lang.IllegalStateException: Expected END_OBJECT but was END_ARRAY at line 1 column 15 path $.list_6[1]
    //验证是否通过: ❌ 第1、3、4、7、8 结果不对
}

fun sample_7_list_by_bean() {
    println("Bean类-数组集合-泛型容错<Double>")
    faultRange.forEachIndexed { index, it ->
        val json = "{\"list_7\":[${it}]}"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson(json, TestBean::class.java)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(mapOf("list_7" to bean.list_7)))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① {"list_7":[null]} -> {"list_7":[null]}
    //② {"list_7":[""]} -> {"list_7":[0.0]}
    //③ {"list_7":["字符串"]} -> com.google.gson.JsonSyntaxException: java.lang.IllegalStateException: Expected END_OBJECT but was END_ARRAY at line 1 column 18 path $.list_7[1]
    //④ {"list_7":[false]} -> com.google.gson.JsonSyntaxException: java.lang.IllegalStateException: Expected END_OBJECT but was END_ARRAY at line 1 column 18 path $.list_7[1]
    //⑤ {"list_7":[0]} -> {"list_7":[0.0]}
    //⑥ {"list_7":[0.0]} -> {"list_7":[0.0]}
    //⑦ {"list_7":[{}]} -> com.google.gson.JsonSyntaxException: java.lang.IllegalStateException: Expected END_OBJECT but was END_ARRAY at line 1 column 15 path $.list_7[1]
    //⑧ {"list_7":[[]]} -> com.google.gson.JsonSyntaxException: java.lang.IllegalStateException: Expected END_OBJECT but was END_ARRAY at line 1 column 15 path $.list_7[1]
    //验证是否通过: ❌ 第1、3、4、7、8 结果不对
}

fun sample_8_list_by_bean() {
    println("Bean类-数组集合-泛型容错<BigDecimal>")
    faultRange.forEachIndexed { index, it ->
        val json = "{\"list_8\":[${it}]}"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson(json, TestBean::class.java)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(mapOf("list_8" to bean.list_8)))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① {"list_8":[null]} -> {"list_8":[null]}
    //② {"list_8":[""]} -> {"list_8":[0]}
    //③ {"list_8":["字符串"]} -> com.google.gson.JsonSyntaxException: java.lang.IllegalStateException: Expected END_OBJECT but was END_ARRAY at line 1 column 18 path $.list_8[1]
    //④ {"list_8":[false]} -> {"list_8":[null]}
    //⑤ {"list_8":[0]} -> {"list_8":[0]}
    //⑥ {"list_8":[0.0]} -> {"list_8":[0.0]}
    //⑦ {"list_8":[{}]} -> {"list_8":[null]}
    //⑧ {"list_8":[[]]} -> {"list_8":[null]}
    //验证是否通过: ❌ 第1、3、4、6、7、8 结果不对
}

fun sample_9_list_by_bean() {
    println("Bean类-数组集合-泛型容错<Bean对象>")
    faultRange.forEachIndexed { index, it ->
        val json = "{\"list_9\":[${it}]}"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson(json, TestBean::class.java)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(mapOf("list_9" to bean.list_9)))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① {"list_9":[null]} -> {"list_9":[null]}
    //② {"list_9":[""]} -> {"list_9":[null]}
    //③ {"list_9":["字符串"]} -> {"list_9":[null]}
    //④ {"list_9":[false]} -> {"list_9":[null]}
    //⑤ {"list_9":[0]} -> {"list_9":[null]}
    //⑥ {"list_9":[0.0]} -> {"list_9":[null]}
    //⑦ {"list_9":[{}]} -> {"list_9":[{"base_1":"","base_2":false,"base_3":0,"base_4":0,"base_5":0.0,"base_6":0.0,"base_7":0,"list_1":[],"list_2":[],"list_3":[],"list_4":[],"list_5":[],"list_6":[],"list_7":[],"list_8":[],"list_9":[],"list_10":[],"list_11":[],"map_1":{},"map_2":{},"map_3":{},"map_4":{},"map_5":{},"map_6":{},"map_7":{},"map_8":{},"map_9":{},"map_10":{},"map_11":{}}]}
    //⑧ {"list_9":[[]]} -> {"list_9":[null]}
    //验证是否通过: ❌ 第1、2、3、4、5、6、8 结果不对
}

fun sample_10_list_by_bean() {
    println("Bean类-数组集合-泛型容错<数组集合>")
    faultRange.forEachIndexed { index, it ->
        val json = "{\"list_10\":[${it}]}"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson(json, TestBean::class.java)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(mapOf("list_10" to bean.list_10)))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① {"list_10":[null]} -> {"list_10":[null]}
    //② {"list_10":[""]} -> {"list_10":[null]}
    //③ {"list_10":["字符串"]} -> {"list_10":[null]}
    //④ {"list_10":[false]} -> {"list_10":[null]}
    //⑤ {"list_10":[0]} -> {"list_10":[null]}
    //⑥ {"list_10":[0.0]} -> {"list_10":[null]}
    //⑦ {"list_10":[{}]} -> {"list_10":[null]}
    //⑧ {"list_10":[[]]} -> {"list_10":[[]]}
    //验证是否通过: ❌ 第1、2、3、4、5、6、7 结果不对
}

fun sample_11_list_by_bean() {
    println("Bean类-数组集合-泛型容错<Map集合>")
    faultRange.forEachIndexed { index, it ->
        val json = "{\"list_11\":[${it}]}"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson(json, TestBean::class.java)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(mapOf("list_11" to bean.list_11)))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① {"list_11":[null]} -> {"list_11":[null]}
    //② {"list_11":[""]} -> {"list_11":[{}]}
    //③ {"list_11":["字符串"]} -> {"list_11":[{}]}
    //④ {"list_11":[false]} -> {"list_11":[{}]}
    //⑤ {"list_11":[0]} -> {"list_11":[{}]}
    //⑥ {"list_11":[0.0]} -> {"list_11":[{}]}
    //⑦ {"list_11":[{}]} -> {"list_11":[{}]}
    //⑧ {"list_11":[[]]} -> {"list_11":[{}]}
    //验证是否通过: ❌ 第1 结果不对
}

fun sample_1_map_by_bean() {
    println("Bean类-Map集合-外层容错")
    faultRange.forEachIndexed { index, it ->
        val json = "{\"map_1\":${it}}"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson(json, TestBean::class.java)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(mapOf("map_1" to bean.map_1)))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① {"map_1":null} -> {"map_1":{}}
    //② {"map_1":""} -> {"map_1":{}}
    //③ {"map_1":"字符串"} -> {"map_1":{}}
    //④ {"map_1":false} -> {"map_1":{}}
    //⑤ {"map_1":0} -> {"map_1":{}}
    //⑥ {"map_1":0.0} -> {"map_1":{}}
    //⑦ {"map_1":{}} -> {"map_1":{}}
    //⑧ {"map_1":[]} -> {"map_1":{}}
    //验证是否通过: ✅
}

fun sample_2_map_by_bean() {
    println("Bean类-Map集合-泛型容错<String,String>")
    faultRange.forEachIndexed { index, it ->
        val json = "{\"map_2\":{${it}}}"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson(json, TestBean::class.java)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(mapOf("map_2" to bean.map_2)))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① {"map_11":{null}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 17 path $.map_11.
    //② {"map_11":{""}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 15 path $.map_11.
    //③ {"map_11":{"字符串"}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 18 path $.map_11.
    //④ {"map_11":{false}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 18 path $.map_11.
    //⑤ {"map_11":{0}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 14 path $.map_11.
    //⑥ {"map_11":{0.0}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 16 path $.map_11.
    //⑦ {"map_11":{{}}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected name at line 1 column 12 path $.map_11.
    //⑧ {"map_11":{[]}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected name at line 1 column 12 path $.map_11.
    //验证是否通过: ❌ 第1、2、3、4、5、6、7、8 结果不对
}

fun sample_3_map_by_bean() {
    println("Bean类-Map集合-泛型容错<String,Boolean>")
    faultRange.forEachIndexed { index, it ->
        val json = "{\"map_3\":{${it}}}"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson(json, TestBean::class.java)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(mapOf("map_3" to bean.map_3)))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① {"map_11":{null}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 17 path $.map_11.
    //② {"map_11":{""}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 15 path $.map_11.
    //③ {"map_11":{"字符串"}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 18 path $.map_11.
    //④ {"map_11":{false}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 18 path $.map_11.
    //⑤ {"map_11":{0}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 14 path $.map_11.
    //⑥ {"map_11":{0.0}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 16 path $.map_11.
    //⑦ {"map_11":{{}}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected name at line 1 column 12 path $.map_11.
    //⑧ {"map_11":{[]}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected name at line 1 column 12 path $.map_11.
    //验证是否通过: ❌ 第1、2、3、4、5、6、7、8 结果不对
}

fun sample_4_map_by_bean() {
    println("Bean类-Map集合-泛型容错<String,Int>")
    faultRange.forEachIndexed { index, it ->
        val json = "{\"map_4\":{${it}}}"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson(json, TestBean::class.java)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(mapOf("map_4" to bean.map_4)))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① {"map_11":{null}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 17 path $.map_11.
    //② {"map_11":{""}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 15 path $.map_11.
    //③ {"map_11":{"字符串"}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 18 path $.map_11.
    //④ {"map_11":{false}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 18 path $.map_11.
    //⑤ {"map_11":{0}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 14 path $.map_11.
    //⑥ {"map_11":{0.0}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 16 path $.map_11.
    //⑦ {"map_11":{{}}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected name at line 1 column 12 path $.map_11.
    //⑧ {"map_11":{[]}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected name at line 1 column 12 path $.map_11.
    //验证是否通过: ❌ 第1、2、3、4、5、6、7、8 结果不对
}

fun sample_5_map_by_bean() {
    println("Bean类-Map集合-泛型容错<String,Long>")
    faultRange.forEachIndexed { index, it ->
        val json = "{\"map_5\":{${it}}}"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson(json, TestBean::class.java)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(mapOf("map_5" to bean.map_5)))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① {"map_11":{null}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 17 path $.map_11.
    //② {"map_11":{""}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 15 path $.map_11.
    //③ {"map_11":{"字符串"}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 18 path $.map_11.
    //④ {"map_11":{false}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 18 path $.map_11.
    //⑤ {"map_11":{0}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 14 path $.map_11.
    //⑥ {"map_11":{0.0}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 16 path $.map_11.
    //⑦ {"map_11":{{}}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected name at line 1 column 12 path $.map_11.
    //⑧ {"map_11":{[]}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected name at line 1 column 12 path $.map_11.
    //验证是否通过: ❌ 第1、2、3、4、5、6、7、8 结果不对
}

fun sample_6_map_by_bean() {
    println("Bean类-Map集合-泛型容错<String,Float>")
    faultRange.forEachIndexed { index, it ->
        val json = "{\"map_6\":{${it}}}"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson(json, TestBean::class.java)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(mapOf("map_6" to bean.map_6)))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① {"map_11":{null}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 17 path $.map_11.
    //② {"map_11":{""}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 15 path $.map_11.
    //③ {"map_11":{"字符串"}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 18 path $.map_11.
    //④ {"map_11":{false}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 18 path $.map_11.
    //⑤ {"map_11":{0}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 14 path $.map_11.
    //⑥ {"map_11":{0.0}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 16 path $.map_11.
    //⑦ {"map_11":{{}}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected name at line 1 column 12 path $.map_11.
    //⑧ {"map_11":{[]}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected name at line 1 column 12 path $.map_11.
    //验证是否通过: ❌ 第1、2、3、4、5、6、7、8 结果不对
}

fun sample_7_map_by_bean() {
    println("Bean类-Map集合-泛型容错<String,Double>")
    faultRange.forEachIndexed { index, it ->
        val json = "{\"map_7\":{${it}}}"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson(json, TestBean::class.java)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(mapOf("map_7" to bean.map_7)))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① {"map_11":{null}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 17 path $.map_11.
    //② {"map_11":{""}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 15 path $.map_11.
    //③ {"map_11":{"字符串"}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 18 path $.map_11.
    //④ {"map_11":{false}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 18 path $.map_11.
    //⑤ {"map_11":{0}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 14 path $.map_11.
    //⑥ {"map_11":{0.0}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 16 path $.map_11.
    //⑦ {"map_11":{{}}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected name at line 1 column 12 path $.map_11.
    //⑧ {"map_11":{[]}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected name at line 1 column 12 path $.map_11.
    //验证是否通过: ❌ 第1、2、3、4、5、6、7、8 结果不对
}

fun sample_8_map_by_bean() {
    println("Bean类-Map集合-泛型容错<String,BigDecimal>")
    faultRange.forEachIndexed { index, it ->
        val json = "{\"map_8\":{${it}}}"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson(json, TestBean::class.java)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(mapOf("map_8" to bean.map_8)))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① {"map_11":{null}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 17 path $.map_11.
    //② {"map_11":{""}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 15 path $.map_11.
    //③ {"map_11":{"字符串"}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 18 path $.map_11.
    //④ {"map_11":{false}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 18 path $.map_11.
    //⑤ {"map_11":{0}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 14 path $.map_11.
    //⑥ {"map_11":{0.0}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 16 path $.map_11.
    //⑦ {"map_11":{{}}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected name at line 1 column 12 path $.map_11.
    //⑧ {"map_11":{[]}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected name at line 1 column 12 path $.map_11.
    //验证是否通过: ❌ 第1、2、3、4、5、6、7、8 结果不对
}

fun sample_9_map_by_bean() {
    println("Bean类-Map集合-泛型容错<String,Bean对象>")
    faultRange.forEachIndexed { index, it ->
        val json = "{\"map_9\":{${it}}}"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson(json, TestBean::class.java)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(mapOf("map_9" to bean.map_9)))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① {"map_11":{null}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 17 path $.map_11.
    //② {"map_11":{""}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 15 path $.map_11.
    //③ {"map_11":{"字符串"}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 18 path $.map_11.
    //④ {"map_11":{false}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 18 path $.map_11.
    //⑤ {"map_11":{0}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 14 path $.map_11.
    //⑥ {"map_11":{0.0}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 16 path $.map_11.
    //⑦ {"map_11":{{}}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected name at line 1 column 12 path $.map_11.
    //⑧ {"map_11":{[]}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected name at line 1 column 12 path $.map_11.
    //验证是否通过: ❌ 第1、2、3、4、5、6、7、8 结果不对
}

fun sample_10_map_by_bean() {
    println("Bean类-Map集合-泛型容错<String,数组集合>")
    faultRange.forEachIndexed { index, it ->
        val json = "{\"map_10\":{${it}}}"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson(json, TestBean::class.java)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(mapOf("map_10" to bean.map_10)))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① {"map_11":{null}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 17 path $.map_11.
    //② {"map_11":{""}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 15 path $.map_11.
    //③ {"map_11":{"字符串"}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 18 path $.map_11.
    //④ {"map_11":{false}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 18 path $.map_11.
    //⑤ {"map_11":{0}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 14 path $.map_11.
    //⑥ {"map_11":{0.0}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected ':' at line 1 column 16 path $.map_11.
    //⑦ {"map_11":{{}}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected name at line 1 column 12 path $.map_11.
    //⑧ {"map_11":{[]}} -> com.google.gson.JsonSyntaxException: com.google.gson.stream.MalformedJsonException: Expected name at line 1 column 12 path $.map_11.
    //验证是否通过: ❌ 第1、2、3、4、5、6、7、8 结果不对
}

fun sample_11_map_by_bean() {
    println("Bean类-Map集合-泛型容错<String,Map集合>")
    faultRange.forEachIndexed { index, it ->
        val json = "{\"map_11\":{${it}}}"
        try {
            val bean = GsonFactory.getSingletonGson().fromJson(json, TestBean::class.java)
            print("${number(index)} ${json} -> ")
            println(GsonFactory.getSingletonGson().toJson(mapOf("map_11" to bean.map_11)))
        } catch (e: Exception) {
            print("${number(index)} ${json} -> ")
            println(e)
        }
    }
    println("--------------------------------------------")
    //打印结果
    //① {"list_2":[null]} -> {"list_2":[null]}
    //② {"list_2":[""]} -> {"list_2":[""]}
    //③ {"list_2":["字符串"]} -> {"list_2":["字符串"]}
    //④ {"list_2":[false]} -> {"list_2":["false"]}
    //⑤ {"list_2":[0]} -> {"list_2":["0"]}
    //⑥ {"list_2":[0.0]} -> {"list_2":["0.0"]}
    //⑦ {"list_2":[{}]} -> com.google.gson.JsonSyntaxException: java.lang.IllegalStateException: Expected END_OBJECT but was END_ARRAY at line 1 column 15 path $.list_2[1]
    //⑧ {"list_2":[[]]} -> com.google.gson.JsonSyntaxException: java.lang.IllegalStateException: Expected END_OBJECT but was END_ARRAY at line 1 column 15 path $.list_2[1]
    //验证是否通过: ❌ 第1、7、8结果不对
}

fun number(index: Int): String {
    return when (index) {
        0 -> "①"
        1 -> "②"
        2 -> "③"
        3 -> "④"
        4 -> "⑤"
        5 -> "⑥"
        6 -> "⑦"
        7 -> "⑧"
        else -> ""
    }
}